## golang 1.4.2

=== debian/changelog ===
golang (2:1.4.2-3) unstable; urgency=medium

  * Add missing "prerm" for our new alternatives (thanks piuparts).

 -- Tianon Gravi <admwiggin@gmail.com>  Tue, 05 May 2015 17:38:37 -0600

golang (2:1.4.2-2) unstable; urgency=medium

  * Move "go" and "gofmt" into "/usr/lib/go" and use alternatives to provide
    appropriate symlinks (Closes: #779503, #782301).
  * Relax "golang-go.tools" relationship to Suggests (from Recommends).
  * Add "go get" VCS options to Suggests for golang-go (bzr, git, mercurial,
    subversion).

 -- Tianon Gravi <admwiggin@gmail.com>  Tue, 05 May 2015 00:37:53 -0600

golang (2:1.4.2-1) unstable; urgency=medium

  * New upstream version
    (https://golang.org/doc/devel/release.html#go1.4.minor)

 -- Tianon Gravi <admwiggin@gmail.com>  Sat, 02 May 2015 10:06:34 -0600

golang (2:1.4.1-1~exp1) experimental; urgency=low

  * New upstream version (https://golang.org/doc/go1.4)
    - all editor support files have been removed from misc/ upstream upstream,
      so golang-mode, kate-syntax-go, and vim-syntax-go can no longer be
      provided; see https://github.com/golang/go/wiki/IDEsAndTextEditorPlugins
      for an upstream-maintained list of potential replacements

 -- Tianon Gravi <admwiggin@gmail.com>  Fri, 16 Jan 2015 00:52:10 -0500

=== debian/control ===
# DO NOT EDIT THIS FILE. EDIT debian/control.* instead!
Source: golang
Section: devel
Priority: optional
Maintainer: Go Compiler Team <pkg-golang-devel@lists.alioth.debian.org>
Uploaders: Michael Stapelberg <stapelberg@debian.org>,
           Paul Tagliamonte <paultag@debian.org>,
           Tianon Gravi <admwiggin@gmail.com>
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-golang/golang.git
Vcs-Git: git://anonscm.debian.org/pkg-golang/golang.git
Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
Build-Depends-Indep: po-debconf
Standards-Version: 3.9.6
Homepage: http://golang.org/

Package: golang-go
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
	 golang-src (>= ${source:Version}),
	 golang-go-linux-${go:Hostarch} (= ${source:Version})
Replaces: golang-weekly-go, golang-weekly-tools, golang-tools
Conflicts: golang-weekly-go, golang-weekly-tools, golang-tools
Provides: go-compiler, golang-weekly-go, golang-weekly-tools, golang-tools
Suggests: bzr, git, golang-go.tools, mercurial, subversion
Description: Go programming language compiler
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package provides an assembler, a compiler, and a linker for the
 Go programming language. This is Google's implementation of the Go
 tool chain.

Package: golang-src
Replaces: golang-weekly-src, golang-go (<< 2:1-3~)
Conflicts: golang-weekly-src
Provides: golang-weekly-src
Breaks: golang-go (<< 2:1-3~)
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Go programming language compiler - source files
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package provides the Go programming language source files needed
 for godoc and goinstall.

Package: golang-doc
Replaces: golang-weekly-doc
Conflicts: golang-weekly-doc
Provides: golang-weekly-doc
Depends: ${misc:Depends}, golang-go
Architecture: all
Section: doc
Description: Go programming language compiler - documentation
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a fast,
 statically typed, compiled language that feels like a dynamically
 typed, interpreted language.
 .
 This package provides the documentation for the Go programming
 language. You can view the formatted documentation by running "godoc
 --http=:6060", and then visiting http://localhost:6060/doc/install.html.

Package: golang
Replaces: golang-weekly
Conflicts: golang-weekly
Provides: golang-weekly
Depends: ${misc:Depends},
	 golang-go (>= ${source:Version}),
	 golang-src (>= ${source:Version}),
	 golang-doc (>= ${source:Version})
Architecture: all
Description: Go programming language compiler - metapackage
 The Go programming language is an open source project to make
 programmers more productive. Go is expressive, concise, clean, and
 efficient. Its concurrency mechanisms make it easy to write programs
 that get the most out of multicore and networked machines, while its
 novel type system enables flexible and modular program construction.
 Go compiles quickly to machine code yet has the convenience of
 garbage collection and the power of run-time reflection. It's a
 fast, statically typed, compiled language that feels like a
 dynamically typed, interpreted language.
 .
 This package is a metapackage that, when installed, guarantees
 that (most of) a full Go development environment is installed.

Package: golang-go-linux-amd64
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for linux_amd64
 This package contains the Go standard library,
 compiled for linux_amd64.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-linux-arm
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for linux_arm
 This package contains the Go standard library,
 compiled for linux_arm.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-linux-386
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for linux_386
 This package contains the Go standard library,
 compiled for linux_386.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-freebsd-amd64
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for freebsd_amd64
 This package contains the Go standard library,
 compiled for freebsd_amd64.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-freebsd-arm
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for freebsd_arm
 This package contains the Go standard library,
 compiled for freebsd_arm.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-freebsd-386
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for freebsd_386
 This package contains the Go standard library,
 compiled for freebsd_386.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-windows-amd64
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for windows_amd64
 This package contains the Go standard library,
 compiled for windows_amd64.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-windows-386
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for windows_386
 This package contains the Go standard library,
 compiled for windows_386.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-darwin-amd64
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Breaks: golang-go (<< 2:1.1-2)
Replaces: golang-go (<< 2:1.1-2)
Description: Go standard library compiled for darwin_amd64
 This package contains the Go standard library,
 compiled for darwin_amd64.
 .
 This package is just one of a number of packages, each providing the Go
 standard library for a specific operating system/architecture combination.
 Go supports cross-compilation, so each of these packages is useful on any
 architecture.
 .
 The files contained in this package are independent of the host architecture,
 that is, you can use golang-go-linux-amd64 to generate a binary for
 linux_amd64, even though you are executing the Go compiler on linux_386.

Package: golang-go-darwin-386
Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

PACKAGE = golang

libexecdir := /usr/lib/go
datadir := /usr/share/go
bindir := /bin

# We loop over supported operating systems and architectures multiple times,
# so these two variables contain a centralized version of that code.
# The variables $$os and $$arch can be used inside such a loop.
FOR_GO_ARCH := for os in $$(echo linux freebsd windows darwin netbsd); do \
	archs="amd64 386"; \
	[ "$$os" = "linux" ] || [ "$$os" = "freebsd" ] && archs="amd64 arm 386"; \
	for arch in $$(echo $$archs); do
FOR_GO_ARCH_END := done; done

build-arch build-indep build clean install binary-arch binary-indep binary: debian/control
	+dh --parallel $(opt_no_act) $@

override_dh_auto_clean:
	rm -rf bin pkg
	# golang-go-$os-$arch.install files are auto-generated in override_dh_install
	rm -f debian/golang-go-*.install
	rm -f debian/*+
	rm -f debian/build.stamp
	rm -f test/pass.out test/run.out test/times.out
	rm -rf debian/home

override_dh_auto_build: debian/build.stamp

override_dh_auto_test:
ifeq ($(RUN_TEST), true)
	cd $(CURDIR)/src && \
	$(CURDIR)/debian/test.bash $(GOROOT)/pkg/tool/$(GOHOSTOS)_$(GOHOSTARCH);
else
	:
endif

override_dh_compress:
	dh_compress -Xusr/share/doc/$(PACKAGE)-doc/html -Xusr/share/doc/$(PACKAGE)-doc/godoc

# Generates debian/control from debian/control.base and debian/control.cross.
# In the latter, @OS@ and @ARCH@ are replaced with every supported combination
# of operating system and architecture (e.g. linux_amd64, linux_386, …).
gencontrol:
	echo "# DO NOT EDIT THIS FILE. EDIT debian/control.* instead!" > debian/control.tmp
	cat debian/control.base >> debian/control.tmp
	${FOR_GO_ARCH} \
		BUILDARCHS=all; \
		[ "$$os" = "linux" ] && BUILDARCHS="i386 amd64 armel armhf"; \
		sed -e "s,@OS@,$$os,g; s,@ARCH@,$$arch,g; s,@BUILDARCHS@,$$BUILDARCHS,g" debian/control.cross >> debian/control.tmp; \
	${FOR_GO_ARCH_END}
	mv debian/control.tmp debian/control

override_dh_install:
	-${FOR_GO_ARCH} \
		echo "pkg/$${os}_$${arch} /usr/lib/go/pkg/" > debian/golang-go-$$os-$$arch.install; \
		[ "$$arch" = "amd64" ] && [ "$$os" = "linux" ] && echo "pkg/linux_amd64_race /usr/lib/go/pkg" >> debian/golang-go-$$os-$$arch.install; \
		echo "golang-go-$$os-$$arch: arch-independent-package-contains-binary-or-object" > debian/golang-go-$$os-$$arch.lintian-overrides; \
	${FOR_GO_ARCH_END}
	# Install the native runtime/cgo.a to the golang-go package.
	# runtime/cgo is only built for the native architecture, but the
	# golang-go-OS-ARCH packages are built on one particular buildd, which
	# might either be i386 or amd64.
	echo "listing of $$(pwd):"; ls -hlR .
	echo "listing of GOBIN: ($(GOBIN))"; ls -hlR $(GOBIN)
	for file in $$(cd pkg/ && ls */runtime/cgo.a); do \
		mkdir -p $(CURDIR)/debian/golang-go/usr/lib/go/pkg/$$(dirname $$file); \
		mv pkg/$$file $(CURDIR)/debian/golang-go/usr/lib/go/pkg/$$file; \
	done
	dh_install --fail-missing
	# Remove .syso files of the race detector; it is not used yet and the files are arch-dependent.
	find $(CURDIR)/debian/golang-src/usr/share/go/src/runtime/race -type f -name '*.syso' -delete
	# Remove Plan9 rc(1) scripts
	find $(CURDIR)/debian/golang-src/usr/share/go/src -type f -name "*.rc" -delete
	# Remove empty /usr/share/go/src from golang-go, it is provided by golang-src
	find $(CURDIR)/debian/golang-go/usr/share/go/src -type d -delete
	# Subsequently, /usr/share/go is empty, too, so remove
	find $(CURDIR)/debian/golang-go/usr/share/go -type d -delete
	# For some reason, Go cross-compiles a handful of tools: {yacc,fix,api,vet,cgo}.
	# Delete those, as they cannot be ran anyway.
	# This is tracked upstream at https://code.google.com/p/go/issues/detail?id=5667
	(cd $(CURDIR)/debian/golang-go/usr/lib/go/pkg/tool && find . -depth -path "./$(GOHOSTOS)_$(GOHOSTARCH)*" -prune -o -delete)
	# Touch built and installed files and directories to have same timestamp
	touch $(CURDIR)/debian/golang-go/usr/lib/go/pkg
	find $(CURDIR)/debian/golang-go/usr/lib/go/pkg -exec touch -r $(CURDIR)/debian/golang-go/usr/lib/go/pkg {} \;

override_dh_strip:
	# strip disabled as golang upstream doesn't support it and it makes go
	# crash. See http://bugs.debian.org/717172

override_dh_prep:
	dh_prep
	echo 'go:Hostarch=$(GOHOSTARCH)' >> debian/golang-go.substvars

override_dh_builddeb:
	dh_builddeb -- -Zxz

override_dh_shlibdeps:
	dh_shlibdeps -Xtestdata -Xtest

debian/build.stamp:
	rm -f debian/build.stamp
	mkdir -p $(GOBIN)
	# Build native tools first, then bootstrap all other GOOS/GOARCH combinations.
	cd src && bash ./make.bash --no-banner
	# For the race detector to work (go test -race), we need to install the
	# std library with the race detector enabled. This will result in
	# having an additional “architecture” directory, e.g. linux_amd64_race.
	#
	# The race detector currently only works on linux/amd64. The check within
	# the following loop works precisely the same way src/race.bash does.
	-${FOR_GO_ARCH} \
		export GOARCH=$$arch; \
		export GOOS=$$os; \
		cd src && bash ./make.bash --no-clean; \
		[ "$$arch" = "amd64" ] && [ "$$os" = "linux" ] && $(GOBIN)/go install -race std; \
		cd ..; \
	${FOR_GO_ARCH_END}
	>debian/build.stamp

opt_no_act =
RUN_TEST := true

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    $(warning no support for disabling optimization)
endif

ifneq (,$(findstring n,$(MAKEFLAGS)))
    opt_no_act = --no-act
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
    RUN_TEST := false
endif

GOROOT := $(CURDIR)
GOROOT_FINAL := $(libexecdir)
GOBIN := $(CURDIR)$(bindir)
GOARM :=

# Always use the 387 floating point unit instead of sse2. This is important to
# ensure that the binaries we build (both when compiling golang on the buildds
# and when users cross-compile for 386) can actually run on older CPUs (where
# old means e.g. an AMD Athlon XP 2400+). See http://bugs.debian.org/753160 and
# https://code.google.com/p/go/issues/detail?id=8152
GO386 := 387

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS 2>/dev/null)
DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
    RUN_TEST := false
    GOHOSTOS := freebsd
else ifeq ($(DEB_BUILD_ARCH_OS), linux)
    GOHOSTOS := linux
else
    $(error unrecongized build host kernel $(DEB_BUILD_ARCH_OS)!)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
    RUN_TEST := false
    GOOS := freebsd
else ifeq ($(DEB_HOST_ARCH_OS), linux)
    GOOS := linux
else
    $(error unrecognized kernel $(DEB_HOST_ARCH_OS)!)
endif

ifeq ($(DEB_BUILD_ARCH_CPU), i386)
    GOHOSTARCH := 386
else ifeq ($(DEB_BUILD_ARCH_CPU), amd64)
    GOHOSTARCH := amd64
else ifeq ($(DEB_BUILD_ARCH_CPU), arm)
    GOHOSTARCH := arm
else ifeq ($(DEB_BUILD_ARCH_CPU), armhf)
    GOHOSTARCH := arm
else
    $(error unrecognized build host instruction set $(DEB_HOST_ARCH_CPU)!)
endif

ifeq ($(DEB_HOST_ARCH_CPU), i386)
    GOARCH := 386
    GOPREFIX := 8
else ifeq ($(DEB_HOST_ARCH_CPU), amd64)
    GOARCH := amd64
    GOPREFIX := 6
else ifeq ($(DEB_HOST_ARCH_CPU), arm)
    GOARCH := arm
    GOPREFIX := 5
ifeq ($(DEB_HOST_ARCH), armel)
    RUN_TEST := false
    GOARM := 5
else ifeq ($(DEB_HOST_ARCH), armhf)
    GOARM := 6
else
    $(error unrecognized arm architecture $(DEB_HOST_ARCH)!)
endif
else
    $(error unrecognized instruction set $(DEB_HOST_ARCH_CPU)!)
endif

export GOROOT GOROOT_FINAL GOOS GOARCH GOARM GOBIN GOHOSTARCH GOHOSTOS GO386

.PHONY: build clean install binary-arch binary-indep binary

## golang 1.4.3

=== src/lib9/utf/Makefile ===
# Copyright 2010 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

# The library is built by the Makefile in the parent directory.
# This Makefile only builds mkrunetype.
# GOROOT, GOOS, and GOARCH must be set explicitly.

TARG=mkrunetype

UnicodeData-%.txt:
	curl http://www.unicode.org/Public/$*/ucd/UnicodeData.txt >_$@
	mv _$@ $@

mkrunetype: mkrunetype.c
	cc -I../../../include -o mkrunetype -L$(GOROOT)/pkg/obj/$(GOOS)_$(GOARCH)/ mkrunetype.c -l9

runetypebody-%.h: mkrunetype UnicodeData-%.txt
	mkrunetype -p UnicodeData-$*.txt >_$@
	mv _$@ $@

CLEANFILES+=UnicodeData.txt

UNICODE_VERSION=6.3.0

test: mkrunetype UnicodeData-$(UNICODE_VERSION).txt
	mkrunetype -c UnicodeData-$(UNICODE_VERSION).txt

clean:
	rm -f UnicodeData.txt mkrunetype

=== debian/changelog ===
golang (2:1.4.3-3) unstable; urgency=medium

  * Fix FTBFS for non-amd64 architectures due to handling of "-race".

 -- Tianon Gravi <tianon@debian.org>  Mon, 05 Oct 2015 02:04:07 -0700

golang (2:1.4.3-2) unstable; urgency=medium

  * Update Recommends/Suggests, especially to add gcc, etc.
  * Refactor "debian/rules" to utilize debhelper more effectively, especially
    for arch vs indep building (mostly backported from the 1.5+ changes), which
    fixes the "arch:all" FTBFS.

 -- Tianon Gravi <tianon@debian.org>  Sun, 27 Sep 2015 22:06:07 -0700

golang (2:1.4.3-1) unstable; urgency=medium

  * New upstream version (https://golang.org/doc/devel/release.html#go1.4.minor)
    - includes previous CVE and non-CVE security fixes, especially
      TEMP-0000000-1C4729

 -- Tianon Gravi <tianon@debian.org>  Fri, 25 Sep 2015 00:02:31 -0700

golang (2:1.4.2-4) unstable; urgency=high

  * Apply backported CVE fixes (Closes: #795106).
    - CVE-2015-5739: Invalid headers are parsed as valid headers
    - CVE-2015-5740: RFC 7230 3.3.3 4 violation
    - CVE-2015-5741: other discoveries of security-relevant RFC 7230 violations

 -- Tianon Gravi <tianon@debian.org>  Mon, 14 Sep 2015 12:27:57 -0700

=== debian/control ===
--- 
+++ 
@@ -5,23 +5,22 @@
 Maintainer: Go Compiler Team <pkg-golang-devel@lists.alioth.debian.org>
 Uploaders: Michael Stapelberg <stapelberg@debian.org>,
            Paul Tagliamonte <paultag@debian.org>,
-           Tianon Gravi <admwiggin@gmail.com>
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-golang/golang.git
+           Tianon Gravi <tianon@debian.org>
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-golang/golang.git
 Vcs-Git: git://anonscm.debian.org/pkg-golang/golang.git
-Build-Depends: debhelper (>= 7.4.10), bison, ed, mawk | awk, perl, netbase
-Build-Depends-Indep: po-debconf
+Build-Depends: bison, debhelper (>= 8.9.7), ed, mawk | awk, netbase, perl
 Standards-Version: 3.9.6
-Homepage: http://golang.org/
+Homepage: https://golang.org
 
 Package: golang-go
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends},
-	 golang-src (>= ${source:Version}),
-	 golang-go-linux-${go:Hostarch} (= ${source:Version})
-Replaces: golang-weekly-go, golang-weekly-tools, golang-tools
-Conflicts: golang-weekly-go, golang-weekly-tools, golang-tools
-Provides: go-compiler, golang-weekly-go, golang-weekly-tools, golang-tools
-Suggests: bzr, git, golang-go.tools, mercurial, subversion
+Architecture: amd64 armel armhf i386
+Depends: golang-go-linux-${go:Hostarch} (= ${source:Version}),
+         golang-src (>= ${source:Version}),
+         ${misc:Depends},
+         ${perl:Depends},
+         ${shlibs:Depends}
+Recommends: g++, gcc, libc6-dev, pkg-config
+Suggests: bzr, ca-certificates, git, golang-golang-x-tools, mercurial, subversion
 Description: Go programming language compiler
  The Go programming language is an open source project to make
  programmers more productive. Go is expressive, concise, clean, and
@@ -38,12 +37,8 @@
  tool chain.
 
 Package: golang-src
-Replaces: golang-weekly-src, golang-go (<< 2:1-3~)
-Conflicts: golang-weekly-src
-Provides: golang-weekly-src
-Breaks: golang-go (<< 2:1-3~)
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Architecture: amd64 armel armhf i386
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Go programming language compiler - source files
  The Go programming language is an open source project to make
  programmers more productive. Go is expressive, concise, clean, and
@@ -59,10 +54,7 @@
  for godoc and goinstall.
 
 Package: golang-doc
-Replaces: golang-weekly-doc
-Conflicts: golang-weekly-doc
-Provides: golang-weekly-doc
-Depends: ${misc:Depends}, golang-go
+Depends: golang-go, ${misc:Depends}
 Architecture: all
 Section: doc
 Description: Go programming language compiler - documentation
@@ -81,13 +73,10 @@
  --http=:6060", and then visiting http://localhost:6060/doc/install.html.
 
 Package: golang
-Replaces: golang-weekly
-Conflicts: golang-weekly
-Provides: golang-weekly
-Depends: ${misc:Depends},
-	 golang-go (>= ${source:Version}),
-	 golang-src (>= ${source:Version}),
-	 golang-doc (>= ${source:Version})
+Depends: golang-doc (>= ${source:Version}),
+         golang-go (>= ${source:Version}),
+         golang-src (>= ${source:Version}),
+         ${misc:Depends}
 Architecture: all
 Description: Go programming language compiler - metapackage
  The Go programming language is an open source project to make
@@ -104,10 +93,8 @@
  that (most of) a full Go development environment is installed.
 
 Package: golang-go-linux-amd64
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Architecture: amd64 armel armhf i386
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for linux_amd64
  This package contains the Go standard library,
  compiled for linux_amd64.
@@ -122,10 +109,8 @@
  linux_amd64, even though you are executing the Go compiler on linux_386.
 
 Package: golang-go-linux-arm
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Architecture: amd64 armel armhf i386
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for linux_arm
  This package contains the Go standard library,
  compiled for linux_arm.
@@ -140,10 +125,8 @@
  linux_amd64, even though you are executing the Go compiler on linux_386.
 
 Package: golang-go-linux-386
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Architecture: amd64 armel armhf i386
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for linux_386
  This package contains the Go standard library,
  compiled for linux_386.
@@ -159,9 +142,7 @@
 
 Package: golang-go-freebsd-amd64
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for freebsd_amd64
  This package contains the Go standard library,
  compiled for freebsd_amd64.
@@ -177,9 +158,7 @@
 
 Package: golang-go-freebsd-arm
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for freebsd_arm
  This package contains the Go standard library,
  compiled for freebsd_arm.
@@ -195,9 +174,7 @@
 
 Package: golang-go-freebsd-386
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for freebsd_386
  This package contains the Go standard library,
  compiled for freebsd_386.
@@ -213,9 +190,7 @@
 
 Package: golang-go-windows-amd64
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for windows_amd64
  This package contains the Go standard library,
  compiled for windows_amd64.
@@ -231,9 +206,7 @@
 
 Package: golang-go-windows-386
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for windows_386
  This package contains the Go standard library,
  compiled for windows_386.
@@ -249,9 +222,7 @@
 
 Package: golang-go-darwin-amd64
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
-Breaks: golang-go (<< 2:1.1-2)
-Replaces: golang-go (<< 2:1.1-2)
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
 Description: Go standard library compiled for darwin_amd64
  This package contains the Go standard library,
  compiled for darwin_amd64.
@@ -267,3 +238,25 @@
 
 Package: golang-go-darwin-386
 Architecture: all
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
+Description: Go standard library compiled for darwin_386
+ This package contains the Go standard library,
+ compiled for darwin_386.
+ .
+ This package is just one of a number of packages, each providing the Go
+ standard library for a specific operating system/architecture combination.
+ Go supports cross-compilation, so each of these packages is useful on any
+ architecture.
+ .
+ The files contained in this package are independent of the host architecture,
+ that is, you can use golang-go-linux-amd64 to generate a binary for
+ linux_amd64, even though you are executing the Go compiler on linux_386.
+
+Package: golang-go-netbsd-amd64
+Architecture: all
+Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
+Description: Go standard library compiled for netbsd_amd64
+ This package contains the Go standard library,
+ compiled for netbsd_amd64.
+ .
+ This package is just one of a number of packages, each providing the Go

=== debian/rules ===
#!/usr/bin/make -f
# This file is in the public domain.
# You may freely use, modify, distribute, and relicense it.

export GOROOT := $(CURDIR)
export GOROOT_FINAL := /usr/lib/go
export GOHOSTOS := $(shell ./debian/helpers/goenv.sh echo '$$GOHOSTOS')
export GOHOSTARCH := $(shell ./debian/helpers/goenv.sh echo '$$GOHOSTARCH')

%:
	+dh --parallel $(opt_no_act) $@

# We loop over supported operating systems and architectures multiple times,
# so these two variables contain a centralized version of that code.
# The variables $$os and $$arch can be used inside such a loop.
FOR_GO_ARCH := set -ex; \
	for os in $$(echo linux freebsd windows darwin netbsd); do \
		archs="amd64 386"; \
		[ "$$os" = "linux" ] || [ "$$os" = "freebsd" ] && archs="amd64 arm 386"; \
		for arch in $$(echo $$archs); do
FOR_GO_ARCH_END := done; done

override_dh_auto_clean:
	# golang-go-$os-$arch.install files are auto-generated in override_dh_install
	rm -f debian/golang-go-*-*.install
	# remove autogenerated files
	rm -f \
		src/cmd/cgo/zdefaultcc.go \
		src/cmd/gc/opnames.h \
		src/cmd/go/zdefaultcc.go \
		src/liblink/anames*.c \
		src/runtime/zaexperiment.h \
		src/runtime/zasm_*_*.h \
		src/runtime/zgoarch_*.go \
		src/runtime/zgoos_*.go \
		src/runtime/zruntime_defs_*_*.go \
		src/runtime/zsys_*_*.s \
		src/runtime/zversion.go
	# remove built objects
	rm -rf bin pkg

override_dh_auto_test-arch:
	set -ex; \
		cd src; \
		export PATH="$(GOROOT)/bin:$$PATH"; \
		eval "$$(go tool dist env)"; \
		bash run.bash --no-rebuild;
	# remove test artifacts
	rm -f \
		test/bench/shootout/6.out \
		test/bench/shootout/*.6

override_dh_compress-indep:
	dh_compress -Xusr/share/doc/golang-doc/html -Xusr/share/doc/golang-doc/godoc

# Generates debian/control from debian/control.base and debian/control.cross.
# In the latter, @OS@ and @ARCH@ are replaced with every supported combination
# of operating system and architecture (e.g. linux_amd64, linux_386, …).
gencontrol:
	echo "# DO NOT EDIT THIS FILE. EDIT debian/control.* instead!" > debian/control.tmp
	cat debian/control.base >> debian/control.tmp
	${FOR_GO_ARCH} \
		BUILDARCHS=all; \
		[ "$$os" = "linux" ] && BUILDARCHS="amd64 armel armhf i386"; \
		sed -e "s,@OS@,$$os,g; s,@ARCH@,$$arch,g; s,@BUILDARCHS@,$$BUILDARCHS,g" debian/control.cross >> debian/control.tmp; \
	${FOR_GO_ARCH_END}
	mv debian/control.tmp debian/control

install-overrides:
	# go install: -race is only supported on linux/amd64, freebsd/amd64, darwin/amd64 and windows/amd64
	${FOR_GO_ARCH} \
		echo "pkg/$${os}_$${arch} /usr/lib/go/pkg/" > debian/golang-go-$$os-$$arch.install; \
		[ "$$arch" = '$(GOHOSTARCH)' -a "$$arch" = 'amd64' -a "$$os" = '$(GOHOSTOS)' -a "$$os" = 'linux' ] \
			&& echo "pkg/$${os}_$${arch}_race /usr/lib/go/pkg/" >> debian/golang-go-$$os-$$arch.install; \
		echo "golang-go-$$os-$$arch: arch-independent-package-contains-binary-or-object" > debian/golang-go-$$os-$$arch.lintian-overrides; \
	${FOR_GO_ARCH_END}

override_dh_install-indep:
	./debian/rules install-overrides
	dh_install --fail-missing

override_dh_install-arch:
	./debian/rules install-overrides
	# Install the native runtime/cgo.a to the golang-go package.
	# runtime/cgo is only built for the native architecture, but the
	# golang-go-OS-ARCH packages are built on one particular buildd, which
	# might either be i386 or amd64.
	for file in pkg/*/runtime/cgo.a; do \
		mkdir -p debian/golang-go/usr/lib/go/$$(dirname $$file); \
		mv $$file debian/golang-go/usr/lib/go/$$file; \
	done
	dh_install --fail-missing
	# Remove .syso files of the race detector; it is not used yet and the files are arch-dependent.
	find debian/golang-src/usr/share/go/src/runtime/race -type f -name '*.syso' -delete
	# Remove Plan9 rc(1) scripts
	find debian/golang-src/usr/share/go/src -type f -name '*.rc' -delete
	# Remove empty /usr/share/go/src from golang-go, it is provided by golang-src
	find debian/golang-go/usr/share/go/src -type d -delete
	# Subsequently, /usr/share/go is empty, too, so remove
	find debian/golang-go/usr/share/go -type d -delete
	# For some reason, Go cross-compiles a handful of tools: {yacc,fix,api,vet,cgo}.
	# Delete those, as they cannot be ran anyway.
	# This is tracked upstream at https://code.google.com/p/go/issues/detail?id=5667
	(cd debian/golang-go/usr/lib/go/pkg/tool && find . -depth -path "./$(GOHOSTOS)_$(GOHOSTARCH)*" -prune -o -delete)
	# Touch built and installed files and directories to have same timestamp
	touch debian/golang-go/usr/lib/go/pkg
	find debian/golang-go/usr/lib/go/pkg -exec touch -r $(CURDIR)/debian/golang-go/usr/lib/go/pkg {} \;

override_dh_strip:
	# strip disabled as golang upstream doesn't support it and it makes go
	# crash. See http://bugs.debian.org/717172

override_dh_prep:
	dh_prep
	echo 'go:Hostarch=$(GOHOSTARCH)' >> debian/golang-go.substvars

override_dh_shlibdeps:
	dh_shlibdeps -Xtestdata -Xtest

override_dh_auto_build:
	[ -f VERSION ] || echo "debian snapshot +$$(dpkg-parsechangelog -SVersion)" > VERSION
	# Build native tools first, then bootstrap all other GOOS/GOARCH combinations.
	cd src \
		&& $(CURDIR)/debian/helpers/goenv.sh \
			bash ./make.bash --no-banner
	# For the race detector to work (go test -race), we need to install the
	# std library with the race detector enabled. This will result in
	# having an additional “architecture” directory, e.g. linux_amd64_race.
	#
	# The race detector currently only works on linux/amd64. The check within
	# the following loop works precisely the same way src/race.bash does.
	#
	# go install: -race is only supported on linux/amd64, freebsd/amd64, darwin/amd64 and windows/amd64
	${FOR_GO_ARCH} \
		cd src \
			&& $(CURDIR)/debian/helpers/goenv.sh \
				GOARCH=$$arch GOOS=$$os \
				bash ./make.bash --no-clean --no-banner; \
		if [ "$$arch" = '$(GOHOSTARCH)' -a "$$arch" = 'amd64' -a "$$os" = "$(GOHOSTOS)" -a "$$os" = 'linux' ]; then \
			$(CURDIR)/debian/helpers/goenv.sh \
				GOARCH=$$arch GOOS=$$os \
				$(GOROOT)/bin/go install -race std; \
		fi; \
		cd ..; \
	${FOR_GO_ARCH_END}

opt_no_act :=
ifneq (,$(findstring n,$(MAKEFLAGS)))
	opt_no_act := --no-act
endif
